commit c5d27945075095ee56c92eee36a81aa239a53494
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Wed Dec 3 15:06:10 2025 +0000

    DMARC: logging

diff --git a/src/src/functions.h b/src/src/functions.h
index 873b8c8be..a15369af9 100644
--- a/src/src/functions.h
+++ b/src/src/functions.h
@@ -20,7 +20,6 @@ are in in fact in separate headers. */
 
 
 #ifndef DISABLE_TLS
-extern gstring *	add_tls_info_for_log(gstring *);
 extern const char *	std_dh_prime_default(void);
 extern const char *	std_dh_prime_named(const uschar *);
 
@@ -106,8 +105,10 @@ extern uschar *acl_standalone_setvar(const uschar *, BOOL);
 
 extern tree_node *acl_var_create(const uschar *);
 extern void    acl_var_write(uschar *, uschar *, void *);
+extern gstring * add_dmarc_info_for_log(gstring *);
 extern void    add_driver_info(driver_info **, const driver_info *, size_t);
 extern gstring * add_spf_info_for_log(gstring *);
+extern gstring * add_tls_info_for_log(gstring *);
 
 extern void    assert_no_variables(void *, int, const char *, int);
 extern void    atrn_handle_customer(void);
diff --git a/src/src/globals.c b/src/src/globals.c
index be5afe736..610c72909 100644
--- a/src/src/globals.c
+++ b/src/src/globals.c
@@ -979,6 +979,10 @@ bit_table log_options[]        = { /* must be in alphabetical order,
 #ifndef DISABLE_DKIM
   BIT_TABLE(L, dkim),
   BIT_TABLE(L, dkim_verbose),
+#endif
+#ifdef EXIM_HAVE_DMARC
+  BIT_TABLE(L, dmarc),
+  BIT_TABLE(L, dmarc_verbose),
 #endif
   BIT_TABLE(L, dnslist_defer),
   BIT_TABLE(L, dnssec),
diff --git a/src/src/macros.h b/src/src/macros.h
index 0b69bb83f..6c7d8b085 100644
--- a/src/src/macros.h
+++ b/src/src/macros.h
@@ -470,6 +470,8 @@ enum logbit {
   Li_delivery_size,
   Li_dkim,
   Li_dkim_verbose,
+  Li_dmarc,
+  Li_dmarc_verbose,
   Li_dnssec,
   Li_ident_timeout,
   Li_incoming_interface,
diff --git a/src/src/miscmods/dmarc.c b/src/src/miscmods/dmarc.c
index be5d68c3a..8d840ae84 100644
--- a/src/src/miscmods/dmarc.c
+++ b/src/src/miscmods/dmarc.c
@@ -431,7 +431,8 @@ The EDITME provides a DMARC_API variable */
     dmarc_alignment_dkim =
       dmarc_dkim_alignment == DMARC_POLICY_DKIM_ALIGNMENT_PASS;
 
-    log_write(0, LOG_MAIN, "DMARC results: spf_domain=%s dmarc_domain=%s "
+    if (LOGGING(dmarc_verbose))
+      log_write(0, LOG_MAIN, "DMARC results: spf_domain=%s dmarc_domain=%s "
 			   "spf_align=%s dkim_align=%s enforcement='%s'",
 			   spf_sender_domain, dmarc_used_domain,
 			   dmarc_alignment_spf  ? "yes" : "no",
diff --git a/src/src/miscmods/dmarc_native.c b/src/src/miscmods/dmarc_native.c
index d073e4274..02eb5dbd3 100644
--- a/src/src/miscmods/dmarc_native.c
+++ b/src/src/miscmods/dmarc_native.c
@@ -628,14 +628,12 @@ use the sp.  Otherwise use the p. */
       }
     }
 
-  // the alignments would be results of the DMARC evaluation
-  // - we have them already, from the dkim & spf processing
-
   if (has_dmarc_record && !dmarc_abort)
     {
-    /* Log results.  Robably should have a log_selector to reduce noise. */
+    /* Log results. */
 
-    log_write(0, LOG_MAIN, "DMARC results: spf_domain=%s dmarc_domain=%s "
+    if (LOGGING(dmarc_verbose))
+      log_write(0, LOG_MAIN, "DMARC results: spf_domain=%s dmarc_domain=%s "
 			   "spf_align=%s dkim_align=%s enforcement='%s'",
 			   spf_sender_domain, dmarc_used_domain,
 			   dmarc_alignment_spf  ? "yes" : "no",
diff --git a/src/src/receive.c b/src/src/receive.c
index a0fcffd06..7827d0288 100644
--- a/src/src/receive.c
+++ b/src/src/receive.c
@@ -1376,6 +1376,21 @@ else if (LOGGING(spf) && Ustrcmp(expand_string(CUS"$spf_result"), "pass") == 0)
 return g;
 }
 
+gstring *
+add_dmarc_info_for_log(gstring * g)
+{
+#ifdef EXIM_HAVE_DMARC
+if (LOGGING(dmarc_verbose))
+  {
+  const uschar * s = expand_string(CUS"$dmarc_status");
+  if (*s) g = string_append(g, 2, US" DMARC=", s);
+  }
+else if (LOGGING(dmarc) && Ustrcmp(expand_string(CUS"$dmarc_status"), "accept") == 0)
+  g = string_catn(g, US" DMARC", 6);
+#endif
+return g;
+}
+
 /* Called for acceptance and rejecting log lines. This adds information about
 the calling host to a string that is being built dynamically.
 
@@ -4099,10 +4114,7 @@ if (message_reference)
   g = string_append(g, 2, US" R=", message_reference);
 
 g = add_host_info_for_log(g);
-
-#ifndef DISABLE_TLS
 g = add_tls_info_for_log(g);
-#endif
 
 if (sender_host_authenticated)
   {
@@ -4156,6 +4168,8 @@ if (LOGGING(dkim))
   }
 #endif
 
+g = add_dmarc_info_for_log(g);
+
 if (LOGGING(receive_time))
   {
   struct timeval diff = received_time_complete;
diff --git a/src/src/smtp_in.c b/src/src/smtp_in.c
index 6cfc36f7a..d694c8d7a 100644
--- a/src/src/smtp_in.c
+++ b/src/src/smtp_in.c
@@ -1483,7 +1483,6 @@ return string_from_gstring(g);
 
 
 
-#ifndef DISABLE_TLS
 /* Append TLS-related information to a log line
 
 Arguments:
@@ -1494,13 +1493,14 @@ Returns:	Allocated string or NULL
 gstring *
 add_tls_info_for_log(gstring * g)
 {
+#ifndef DISABLE_TLS
 if (LOGGING(tls_cipher) && tls_in.cipher)
   {
   g = string_append(g, 2, US" X=", tls_in.cipher);
-#ifndef DISABLE_TLS_RESUME
+# ifndef DISABLE_TLS_RESUME
   if (LOGGING(tls_resumption) && tls_in.resumption & RESUME_USED)
     g = string_catn(g, US"*", 1);
-#endif
+# endif
   }
 if (LOGGING(tls_certificate_verified) && tls_in.peercert)
   g = string_append(g, 2, US" CV=", tls_in.certificate_verified? "yes":"no");
@@ -1509,8 +1509,8 @@ if (LOGGING(tls_peerdn) && tls_in.peerdn)
 if (LOGGING(tls_sni) && tls_in.sni)
   g = string_append(g, 2, US" SNI=", string_printing2(tls_in.sni, SP_TAB|SP_SPACE));
 return g;
-}
 #endif
+}
 
 
 
@@ -1547,7 +1547,6 @@ Returns:     nothing
 void
 smtp_log_no_mail(void)
 {
-uschar * s;
 gstring * g = NULL;
 
 if (smtp_mailcmd_count > 0 || !LOGGING(smtp_no_mail))
@@ -1559,17 +1558,12 @@ if (sender_host_authenticated)
   if (authenticated_id) g = string_append(g, 2, US":", authenticated_id);
   }
 
-#ifndef DISABLE_TLS
 g = add_tls_info_for_log(g);
-#endif
-
 g = s_connhad_log(g);
 
-if (!(s = string_from_gstring(g))) s = US"";
-
-log_write(0, LOG_MAIN, "no MAIL in %sSMTP connection from %s D=%s%s",
+log_write(0, LOG_MAIN, "no MAIL in %sSMTP connection from %s D=%s%#Y",
   f.tcp_in_fastopen ? f.tcp_in_fastopen_data ? US"TFO* " : US"TFO " : US"",
-  host_and_ident(FALSE), string_timesince(&smtp_connection_start), s);
+  host_and_ident(FALSE), string_timesince(&smtp_connection_start), g);
 }
 
 
@@ -2178,21 +2172,13 @@ static void
 log_connect_tls_drop(const uschar * what, const uschar * log_msg)
 {
 if (log_reject_target)
-  {
-#ifdef DISABLE_TLS
-  uschar * tls = NULL;
-#else
-  gstring * g = add_tls_info_for_log(NULL);
-  uschar * tls = string_from_gstring(g);
-#endif
   log_write(L_connection_reject,
-    log_reject_target, "%s%s%s dropped by %s%s%s",
+    log_reject_target, "%s%s%#Y dropped by %s%s%s",
     LOGGING(dnssec) && sender_host_dnssec ? US" DS" : US"",
     host_and_ident(TRUE),
-    tls ? tls : US"",
+    add_tls_info_for_log(NULL),
     what,
     log_msg ? US": " : US"", log_msg);
-  }
 }
 
 
@@ -3264,28 +3250,16 @@ the connection is not forcibly to be dropped, return 0. Otherwise, log why it
 is closing if required and return 2.  */
 
 if (log_reject_target)
-  {
-#ifndef DISABLE_TLS
-  gstring * tls = add_tls_info_for_log(NULL);
-#else
-  gstring * tls = NULL;
-#endif
-#ifdef EXIM_HAVE_SPF
-  gstring * spf= add_spf_info_for_log(NULL);
-#else
-  gstring * spf = NULL;
-#endif
-
   log_write(where == ACL_WHERE_CONNECT ? L_connection_reject : 0,
-    log_reject_target, "%s%s%#Y%s%#Y %srejected %s%s",
+    log_reject_target, "%s%s%#Y%s%#Y%#Y %srejected %s%s",
     LOGGING(dnssec) && sender_host_dnssec ? US" DS" : US"",
     host_and_ident(TRUE),
-    tls,
+    add_tls_info_for_log(NULL),
     sender_info,
-    spf,
+    add_spf_info_for_log(NULL),
+    add_dmarc_info_for_log(NULL),
     rc == FAIL ? US"" : US"temporarily ",
     what, log_msg);
-  }
 
 if (!drop) return 0;
 

